/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NEXT = 258,
     TODAY = 259,
     TOMORROW = 260,
     YESTERDAY = 261,
     WEEKEND = 262,
     WEEK = 263,
     MONTH = 264,
     YEAR = 265,
     OCLOCK = 266,
     DTMONTH = 267,
     DTDAYOFWEEK = 268,
     MIDNIGHT = 269,
     NOON = 270,
     AFTERNOON = 271,
     EVENING = 272,
     MORNING = 273,
     AMPM = 274,
     DAYSFROM = 275,
     WEEKSFROM = 276,
     A = 277,
     AT = 278,
     OF = 279,
     ON = 280,
     THE = 281,
     THIS = 282,
     NUM = 283,
     YEARNUM = 284,
     ORDNUM = 285,
     DASH = 286,
     COLON = 287,
     THRU = 288
   };
#endif
/* Tokens.  */
#define NEXT 258
#define TODAY 259
#define TOMORROW 260
#define YESTERDAY 261
#define WEEKEND 262
#define WEEK 263
#define MONTH 264
#define YEAR 265
#define OCLOCK 266
#define DTMONTH 267
#define DTDAYOFWEEK 268
#define MIDNIGHT 269
#define NOON 270
#define AFTERNOON 271
#define EVENING 272
#define MORNING 273
#define AMPM 274
#define DAYSFROM 275
#define WEEKSFROM 276
#define A 277
#define AT 278
#define OF 279
#define ON 280
#define THE 281
#define THIS 282
#define NUM 283
#define YEARNUM 284
#define ORDNUM 285
#define DASH 286
#define COLON 287
#define THRU 288




/* Copy the first part of user declarations.  */
#line 20 "src/libs/calcmd/parsecmd.y"

#include <config.h>
#include <xpl.h>
#include <memmgr.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <bongocal.h>
#include <calcmd.h>
#include <setjmp.h>
    

static int VerboseMode;
static uint64_t BaseTime;


enum skip_type {
    SKIP_NONE =   0,
    SKIP_DAY =    1,
    SKIP_WEEK =   2,
    SKIP_MONTH =  3,
    SKIP_YEAR =   4,
};

struct daterange {      /*  convention: data in this struct can be set to  */
    BongoCalTime begin;    /*  -1 to indicate unknown or unspecified value    */
    BongoCalTime end;
    enum skip_type skip;
};

struct strparser {
    /* input */
    char *str;

    /* result */
    struct daterange *date;
    char *desc;

    /* internal */
    struct daterange *defaults;
    int idx;
    char *dptr;
    void *mempool;
    jmp_buf bailenv;
};

static int
init_strparser (struct strparser *p, char *str)
{    
    p->str = str;
    p->idx = 0;
    p->defaults = NULL;
    p->date = NULL;
    p->desc = MemMalloc(strlen(str) + 1);
    if (!p->desc) {
        return 0;
    }
    strcpy(p->desc, str);
    p->desc[0] = 0;
    p->dptr = p->desc;
    p->mempool = 
        MemPrivatePoolAlloc("Calendar Command Parser Pool", 
                            sizeof(struct daterange), 0, 100, TRUE, TRUE, 
                            NULL, NULL, NULL);
    if (!p->mempool) {
        MemFree(p->desc);
        return 0;
    }
    return 1;
}


static void
destroy_strparser (struct strparser *p)
{
    MemFree(p->desc);
    MemPrivatePoolFree(p->mempool);
}


static void
dump_daterange(struct daterange *d)
{
    if (!VerboseMode) {
        return;
    }
    fprintf (stderr, "%4d-%02d-%02d %02d:%02d to %4d-%02d-%02d %02d:%02d %s\n",
             d->begin.year, d->begin.month + 1, d->begin.day, 
             d->begin.hour, d->begin.minute,
             d->end.year, d->end.month + 1, d->end.day, 
             d->end.hour, d->end.minute,
             (SKIP_NONE == d->skip ? "" : 
              SKIP_DAY == d->skip ? "SKIP_DAY" :
              SKIP_WEEK == d->skip ? "SKIP_WEEK" :
              SKIP_MONTH == d->skip ? "SKIP_MONTH" :
              SKIP_YEAR == d->skip ? "SKIP_YEAR" :
              "SKIP_INVALID!!"));
}


static BongoCalTime *
skiptm (BongoCalTime *dt, enum skip_type skip, int amount)
{
    switch (skip) {
    case SKIP_NONE:
        break;
    case SKIP_DAY:
        dt->day += amount;
        break;
    case SKIP_WEEK:
        dt->day += 7 * amount;
        break;
    case SKIP_MONTH:
        dt->month += amount;
        break;
    case SKIP_YEAR:
        dt->year += amount;
        break;
    }
    *dt = BongoCalTimeAdjust(*dt, 0, 0, 0, 0);
    return dt;
}


static struct daterange *
new_daterange (struct strparser *p)
{
    struct daterange *result = MemPrivatePoolGetEntry(p->mempool);
    if (!result) {
        longjmp (p->bailenv, 1);
    }
    return result;
}


static struct daterange *
daterange_skip (struct daterange *d, int amount)
{
    skiptm (&d->begin, d->skip, amount);
    skiptm (&d->end, d->skip, amount);
    return d;
}


static struct daterange *
new_daterange_from_tms (struct strparser *p, BongoCalTime *begin, BongoCalTime *end)
{
    struct daterange *result = new_daterange(p);

    memcpy(&result->begin, begin, sizeof(BongoCalTime));
    memcpy(&result->end, end, sizeof(BongoCalTime));
    result->skip = SKIP_NONE;
    return result;
}

static struct daterange *
new_daterange_from_dateranges (struct strparser *p, 
                               struct daterange *begin, struct daterange *end)
{
    struct daterange *result = new_daterange(p);;
    uint64_t begin_ts = BongoCalTimeAsUint64 (begin->begin);
    uint64_t end_ts = BongoCalTimeAsUint64 (end->end);

    memcpy(&result->begin, &begin->begin, sizeof(BongoCalTime));
    memcpy(&result->end, &end->end, sizeof(BongoCalTime));

    if (BongoCalTimeGetDayOfYear(result->begin) == BongoCalTimeGetDayOfYear(result->end)) {
        result->end.hour = end->begin.hour;
        result->end.minute = end->begin.minute;
    }

    if (end_ts < begin_ts && end->skip) {
        skiptm (&result->end, end->skip, 1);
    } 

    result->skip = SKIP_NONE;

    dump_daterange(result);

    return result;
}


static struct daterange *
new_daterange_from_timeranges (struct strparser *p,
                               struct daterange *begin, struct daterange *end)
{
    struct daterange *result = new_daterange(p);;
    uint64_t begin_ts = BongoCalTimeAsUint64 (begin->begin);
    uint64_t end_ts = BongoCalTimeAsUint64 (end->end);

    memcpy(&result->begin, &begin->begin, sizeof(BongoCalTime));
    memcpy(&result->end, &end->begin, sizeof(BongoCalTime));

    if (end_ts < begin_ts && end->skip) {
        skiptm (&result->end, end->skip, 1);
    } 

    result->skip = SKIP_NONE;

    dump_daterange(result);

    return result;
}



static struct daterange *
new_date (struct strparser *p, struct daterange *defaults, 
          int year, int month, int day)
{
    struct daterange *result = new_daterange(p);;

    memcpy(&result->begin, &defaults->begin, sizeof(BongoCalTime));
    memcpy(&result->end, &defaults->end, sizeof(BongoCalTime));

    if (-1 != year) {
        result->begin.year = year;
    }
    if (-1 != month) {
        if (-1 == year) {
            if (month - defaults->begin.month < 0) {
                month += 12;
            }
        }
        result->begin.month = month;
    }
    if (-1 != day)   result->begin.day = day;
    result->begin.hour = 0;
    result->begin.minute = 0;
    result->begin.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif

    result->end.year = result->begin.year;
    result->end.month =  result->begin.month;
    result->end.day = result->begin.day;
    result->end.hour = 23;
    result->end.minute = 59;
    result->end.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif
    
    result->skip = SKIP_DAY;

    result->begin = BongoCalTimeAdjust(result->begin, 0, 0, 0, 0);
    result->end = BongoCalTimeAdjust(result->end, 0, 0, 0, 0);
    
    dump_daterange(result);

    return result;
}


static struct daterange *
new_dayofweek (struct strparser *p, struct daterange *defaults, int wday)
{
    struct daterange *result = new_daterange(p);;
    int d;

    memcpy(&result->begin, &defaults->begin, sizeof(BongoCalTime));

    d = wday - BongoCalTimeGetWeekday(result->begin);
    if (d < 0) {
        d += 7;
    }
    result->begin.day += d;
    result->begin = BongoCalTimeAdjust(result->begin, 0, 0, 0, 0);

    result->begin.hour = 0;
    result->begin.minute = 0;
    result->begin.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif

    memcpy(&result->end, &result->begin, sizeof(BongoCalTime));

    result->end.hour = 23;
    result->end.minute = 59;
    result->end.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif

    result->skip = SKIP_WEEK;

    dump_daterange(result);
    return result;
}


static struct daterange *
new_month (struct strparser *p, struct daterange *defaults, int mon, int year)
{
    struct daterange *result = new_daterange(p);;
    int d;

    memcpy(&result->begin, &defaults->begin, sizeof(BongoCalTime));

    if (-1 == mon) {
        result->skip = SKIP_MONTH;
        mon = result->begin.month;
    } else {
        result->skip = SKIP_YEAR;
    }

    d = mon - result->begin.month;
    if (d < 0) {
        d = d + 12;
    }
    result->begin.month += d;
    result->begin = BongoCalTimeAdjust(result->begin, 0, 0, 0, 0);

    result->begin.day = 1;
    result->begin.hour = 0;
    result->begin.minute = 0;
    result->begin.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif
    if (-1 != year) {
        result->begin.year = year;
    }

    memcpy(&result->end, &result->begin, sizeof(BongoCalTime));

    result->end.month = result->begin.month + 1;
    result->end.day = 0;
    result->end.hour = 23;
    result->end.minute = 59;
    result->end.second = 0;
#if 0
    result->end.tm_isdst = -1;
#endif
    result->end = BongoCalTimeAdjust(result->end, 0, 0, 0, 0);

    dump_daterange(result);
    return result;
}


static struct daterange *
new_day_of_month (struct strparser *p, struct daterange *defaults, int day)
{
    struct daterange *result = new_date(p, defaults, -1, -1, day);;

    if (day < defaults->begin.day) {
        skiptm (&result->begin, SKIP_MONTH, 1);
        skiptm (&result->end, SKIP_MONTH, 1);
    } 
    return result;
}


/* pm: 0 for AM, 1 for PM, -1 for unknown */
static struct daterange *
new_time (struct strparser *p, struct daterange *defaults, 
          int hour, int min, int pm)
{
    struct daterange *result = new_daterange(p);;

    if (-1 == pm) { /* guess if they mean pm*/
        pm = hour < 7 ? 1 : 0;
    }

    if (pm && hour < 12) {
        hour += 12;
    }

    memcpy(&result->begin, &defaults->begin, sizeof(BongoCalTime));
    memcpy(&result->end, &defaults->end, sizeof(BongoCalTime));

    result->begin.hour = hour;
    result->begin.minute = min;
    result->begin.second = 0;
#if 0
    result->begin.tm_isdst = -1;
#endif

    result->end.hour = hour;
    result->end.minute = min + 59;
    result->end.second = 0;
#if 0
    result->end.tm_isdst = -1;
#endif

    result->end = BongoCalTimeAdjust(result->end, 0, 0, 0, 0);

    result->skip = SKIP_DAY;

    dump_daterange(result);

    return result;
}


static struct daterange *
force_morning (struct daterange *time)
{
    if (time->begin.hour >= 12) {
        time->begin.hour -= 12;
    }
    if (time->end.hour >= 12) {
        time->end.hour -= 12;
    }
    if (time->end.hour < time->begin.hour) {
        time->end.hour += 12;
    }

    return time;
}


static struct daterange *
force_evening (struct daterange *time)
{
    if (time->begin.hour < 17 && time->begin.hour > 4) {
        time->begin.hour += 12;
    }
    if (time->end.hour < 17 && time->end.hour > 4) {
        time->end.hour += 12;
    }
    return time;
}


static struct daterange *
new_datetime (struct strparser *p, struct daterange *date, struct daterange *time)
{
    struct daterange *result = new_daterange(p);;
    uint64_t begin_ts;
    uint64_t end_ts;

    memcpy(&result->begin, &date->begin, sizeof(BongoCalTime));
    memcpy(&result->end, &date->end, sizeof(BongoCalTime));

    result->begin.hour = time->begin.hour;
    result->begin.minute = time->begin.minute;
    result->begin.second = time->begin.second;
#if 0
    result->begin.tm_isdst = -1;
#endif

    result->end.hour = time->end.hour;
    result->end.minute = time->end.minute;
    result->end.second = time->end.second;
#if 0
    result->end.tm_isdst = -1;
#endif

    result->end = BongoCalTimeAdjust(result->end, 0, 0, 0, 0);

    begin_ts = BongoCalMkTime(&result->begin);
    end_ts = BongoCalMkTime(&result->end);
    if (end_ts < begin_ts) {
        skiptm (&result->end, SKIP_DAY, 1);
    } 
        
    result->skip = date->skip;

    dump_daterange(result);

    return result;
}


static struct daterange *
new_weekend (struct strparser *p, struct daterange *defaults)
{
    struct daterange *sunday;
    struct daterange *friday;
    struct daterange *result;
    uint64_t friday_ts;
    uint64_t sunday_ts;

    sunday = new_dayofweek(p, defaults, 0);
    friday = new_datetime(p, new_dayofweek(p, defaults, 5), 
                             new_time(p, defaults, 17, 0, 0));
    friday_ts = BongoCalMkTime(&friday->begin);
    sunday_ts = BongoCalMkTime(&sunday->end);

    if (friday_ts > sunday_ts) {
        skiptm(&friday->begin, SKIP_WEEK, -1);
        skiptm(&friday->end, SKIP_WEEK, -1);
    }
    result = new_daterange_from_dateranges(p, friday, sunday);
    result->skip = SKIP_WEEK;

    return result;
}


static struct daterange *
new_week (struct strparser *p, struct daterange *defaults)
{
    struct daterange *sunday;
    struct daterange *saturday;
    struct daterange *result;
    time_t saturday_ts;
    time_t sunday_ts;

    sunday = new_dayofweek(p, defaults, 0);
    saturday = new_dayofweek(p, defaults, 6);
    saturday_ts = BongoCalMkTime(&saturday->begin);
    sunday_ts = BongoCalMkTime(&sunday->end);

    if (saturday_ts < sunday_ts) {
        skiptm(&sunday->begin, SKIP_WEEK, -1);
        skiptm(&sunday->end, SKIP_WEEK, -1);
    }
    result = new_daterange_from_dateranges(p, sunday, saturday);
    result->skip = SKIP_WEEK;

    return result;
}



#define TWO_DIGIT_YEAR(_year) (1900 + ((_year) < 20 ? (_year + 100) : (_year)))


typedef union {
    int intval;
    struct daterange *dateval;
} ystype;
#define YYSTYPE ystype

#define YYDEBUG 1

static void
yyerror (struct strparser *p, const char *s)
{
    fprintf (stderr, "yyerror: %s\n", s);
}

int yylex (YYSTYPE *lvalp, struct strparser *p);




/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 564 "src/libs/calcmd/parsecmd.y"
{
    int intval;
    struct daterange *dateval;
}
/* Line 193 of yacc.c.  */
#line 710 "src/libs/calcmd/parsecmd.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 723 "src/libs/calcmd/parsecmd.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  74
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   542

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  34
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  13
/* YYNRULES -- Number of rules.  */
#define YYNRULES  77
/* YYNRULES -- Number of states.  */
#define YYNSTATES  113

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     4,     6,     9,    12,    14,    17,    20,
      24,    26,    28,    32,    35,    38,    43,    45,    47,    49,
      51,    53,    56,    59,    62,    65,    68,    70,    74,    78,
      82,    85,    87,    90,    92,    95,    97,   100,   102,   105,
     107,   110,   113,   116,   119,   122,   124,   126,   128,   130,
     132,   135,   139,   143,   146,   149,   151,   154,   156,   158,
     160,   164,   168,   174,   180,   186,   189,   192,   195,   198,
     201,   205,   209,   213,   217,   219,   222,   224
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      35,     0,    -1,    -1,    39,    -1,     1,    39,    -1,    39,
       1,    -1,    37,    -1,    17,    37,    -1,    18,    37,    -1,
      38,    33,    38,    -1,    38,    -1,    28,    -1,    28,    32,
      28,    -1,    28,    11,    -1,    28,    19,    -1,    28,    32,
      28,    19,    -1,    15,    -1,    14,    -1,    16,    -1,    18,
      -1,    17,    -1,    23,    38,    -1,    18,    38,    -1,    16,
      38,    -1,    17,    38,    -1,    27,    38,    -1,    41,    -1,
      41,    33,    41,    -1,    37,    13,    18,    -1,    37,    13,
      17,    -1,    41,    36,    -1,    36,    -1,    36,    41,    -1,
      40,    -1,     3,    40,    -1,     7,    -1,    27,     7,    -1,
       8,    -1,    27,     8,    -1,     9,    -1,    27,     9,    -1,
       3,    41,    -1,    27,    41,    -1,    41,    36,    -1,    38,
      41,    -1,    42,    -1,    44,    -1,     5,    -1,     6,    -1,
       4,    -1,    25,    41,    -1,    28,    20,    41,    -1,    28,
      21,    41,    -1,     1,    41,    -1,    41,     1,    -1,    43,
      -1,    42,    43,    -1,    13,    -1,    45,    -1,    46,    -1,
      28,    31,    28,    -1,    28,    31,    29,    -1,    28,    31,
      28,    31,    28,    -1,    29,    31,    28,    31,    28,    -1,
      28,    31,    28,    31,    29,    -1,    28,    45,    -1,    12,
      28,    -1,    46,    45,    -1,    12,    46,    -1,    12,    29,
      -1,    28,    45,    29,    -1,    12,    28,    29,    -1,    46,
      45,    29,    -1,    12,    46,    29,    -1,    12,    -1,    24,
      12,    -1,    30,    -1,    26,    30,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   633,   633,   634,   635,   636,   639,   640,   641,   644,
     648,   651,   652,   653,   654,   655,   659,   660,   665,   670,
     675,   680,   681,   682,   683,   684,   687,   688,   692,   697,
     702,   703,   704,   705,   709,   710,   711,   712,   713,   714,
     715,   718,   719,   720,   721,   722,   723,   724,   728,   732,
     733,   734,   739,   744,   745,   748,   749,   752,   753,   754,
     757,   767,   772,   782,   786,   796,   797,   798,   799,   800,
     804,   808,   812,   816,   828,   829,   831,   832
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NEXT", "TODAY", "TOMORROW", "YESTERDAY",
  "WEEKEND", "WEEK", "MONTH", "YEAR", "OCLOCK", "DTMONTH", "DTDAYOFWEEK",
  "MIDNIGHT", "NOON", "AFTERNOON", "EVENING", "MORNING", "AMPM",
  "DAYSFROM", "WEEKSFROM", "A", "AT", "OF", "ON", "THE", "THIS", "NUM",
  "YEARNUM", "ORDNUM", "DASH", "COLON", "THRU", "$accept", "line",
  "timerange", "timespan", "time", "daterange", "nameddaterange", "date",
  "datepartlist", "datepart", "formatteddate", "dtmonth", "ordnum", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    34,    35,    35,    35,    35,    36,    36,    36,    37,
      37,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    39,    39,    39,    39,
      39,    39,    39,    39,    40,    40,    40,    40,    40,    40,
      40,    41,    41,    41,    41,    41,    41,    41,    41,    41,
      41,    41,    41,    41,    41,    42,    42,    43,    43,    43,
      44,    44,    44,    44,    44,    44,    44,    44,    44,    44,
      44,    44,    44,    44,    45,    45,    46,    46
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     1,     2,     2,     1,     2,     2,     3,
       1,     1,     3,     2,     2,     4,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     1,     3,     3,     3,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       2,     3,     3,     2,     2,     1,     2,     1,     1,     1,
       3,     3,     5,     5,     5,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     1,     2,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,    49,    47,    48,    35,    37,    39,    74,
      57,    17,    16,    18,    20,    19,     0,     0,     0,     0,
       0,    11,     0,    76,     0,     0,     6,     0,     0,    33,
       0,    45,    55,    46,    58,    59,     0,     4,     0,    20,
      19,     0,    34,     0,    66,    69,    68,     0,    11,    23,
       7,    10,     8,    10,    21,    75,     0,     0,     0,    77,
      36,    38,    40,     0,     0,    13,    74,    14,     0,     0,
       0,     0,    65,     0,     1,     0,     0,     0,     0,     5,
      54,     0,    43,     6,    10,    56,    59,    67,     0,    24,
      22,    43,    71,    73,    25,     0,     0,    60,    61,    12,
      70,     0,    29,    28,     9,     0,    72,     0,    15,     0,
      62,    64,    63
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    24,    91,    83,    41,    28,    29,    78,    31,    32,
      33,    34,    35
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -20
static const yytype_int16 yypact[] =
{
     305,   366,   396,   -20,   -20,   -20,   -20,   -20,   -20,    42,
     -20,   -20,   -20,   514,   514,   514,   514,    24,   456,   -18,
     426,   495,     1,   -20,    45,   336,    37,   103,     5,   -20,
      66,    39,   -20,   -20,   -20,    22,   456,   -20,    66,   514,
     514,   456,   -20,   154,    25,   -20,    26,   514,    12,   -20,
     -20,    23,   -20,    23,   -20,   -20,   456,   456,   174,   -20,
     -20,   -20,   -20,   134,   194,   -20,   -20,   -20,   456,   456,
     -19,    31,    32,    34,   -20,   475,     9,   514,   214,   -20,
     -20,   456,    28,   -20,    23,   -20,   -20,    47,   234,   -20,
     -20,   -20,   -20,   -20,   -20,   254,   274,    29,   -20,    60,
     -20,    56,   -20,   -20,   -20,   494,   -20,    20,   -20,    62,
     -20,   -20,   -20
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -20,   -20,     3,     7,     0,    90,    95,    17,   -20,    61,
     -20,   -10,    -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -54
static const yytype_int8 yytable[] =
{
      27,    27,    46,    25,    25,    -3,    79,    26,    26,    97,
      98,    72,    59,    49,    51,    53,    54,    30,    38,    43,
      63,    50,    52,    65,    86,    87,   102,   103,   -30,   -30,
      84,    67,    73,    82,    66,    58,    55,    64,    84,    89,
      90,    82,    75,    84,    71,    74,    17,    94,   110,   111,
      76,    66,    10,    88,    92,    93,    77,    63,    84,    99,
     107,   100,   101,    17,    84,    19,   -26,    80,    19,    23,
      44,    45,    23,    43,    64,    84,   106,   104,    84,   108,
      11,    12,    13,    14,    15,    95,    96,   109,    84,    16,
     112,    37,    85,    47,    48,    84,    84,    42,   105,    81,
       0,     0,     0,   -10,    36,    84,    56,     3,     4,     5,
       0,     0,     0,     0,     0,     9,    10,    11,    12,    13,
      39,    40,     0,     0,     0,     0,    16,    17,    18,    19,
      57,    21,    22,    23,   -25,    36,    77,    56,     3,     4,
       5,     0,     0,     0,     0,     0,     9,    10,    11,    12,
      13,    39,    40,     0,   -41,    80,     0,    16,    17,    18,
      19,    57,    21,    22,    23,     0,     0,   -25,    11,    12,
      13,    14,    15,     0,   -50,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -41,    11,    12,
      13,    14,    15,     0,   -42,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -50,    11,    12,
      13,    14,    15,     0,   -44,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -42,    11,    12,
      13,    14,    15,     0,   -53,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -44,    11,    12,
      13,    14,    15,     0,   -51,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -53,    11,    12,
      13,    14,    15,     0,   -52,    80,     0,    16,     0,     0,
       0,    47,    48,     0,     0,     0,     0,   -51,    11,    12,
      13,    14,    15,     0,     0,     0,     0,    16,     0,     0,
       0,    47,    48,     0,     0,    -2,     1,   -52,     2,     3,
       4,     5,     6,     7,     8,     0,     0,     9,    10,    11,
      12,    13,    14,    15,     0,     0,     0,     0,    16,    17,
      18,    19,    20,    21,    22,    23,   -31,    36,     0,    56,
       3,     4,     5,     0,     0,     0,     0,     0,     9,    10,
      11,    12,    13,    39,    40,     0,     0,     0,     0,    16,
      17,    18,    19,    57,    21,    22,    23,    36,     0,     2,
       3,     4,     5,     6,     7,     8,     0,     0,     9,    10,
      11,    12,    13,    14,    15,     0,     0,     0,     0,    16,
      17,    18,    19,    20,    21,    22,    23,    36,     0,     2,
       3,     4,     5,     6,     7,     8,     0,     0,     9,    10,
      11,    12,    13,    39,    40,     0,     0,     0,     0,    16,
      17,    18,    19,    20,    21,    22,    23,    36,     0,    56,
       3,     4,     5,    60,    61,    62,     0,     0,     9,    10,
      11,    12,    13,    39,    40,     0,     0,     0,     0,    16,
      17,    18,    19,    57,    21,    22,    23,    36,     0,    56,
       3,     4,     5,     0,     0,     0,     0,     0,     9,    10,
      11,    12,    13,    39,    40,   -32,    80,     0,     0,    16,
      17,    18,    19,    57,    21,    22,    23,     0,     0,    11,
      12,    13,    14,    15,   -27,    80,     0,     0,    16,     0,
       0,     0,    47,    48,     0,     0,    65,    66,    11,    12,
      13,    14,    15,     0,    67,    68,    69,    16,     0,    17,
       0,    47,    48,     0,     0,     0,    70,    71,    11,    12,
      13,    39,    40,     0,     0,     0,     0,    16,     0,     0,
       0,    47,    48
};

static const yytype_int8 yycheck[] =
{
       0,     1,     9,     0,     1,     0,     1,     0,     1,    28,
      29,    21,    30,    13,    14,    15,    16,     0,     1,     2,
      20,    14,    15,    11,    31,    35,    17,    18,     0,     1,
      30,    19,    31,    30,    12,    18,    12,    20,    38,    39,
      40,    38,    25,    43,    32,     0,    24,    47,    28,    29,
      13,    12,    13,    36,    29,    29,    33,    57,    58,    28,
      31,    29,    28,    24,    64,    26,     0,     1,    26,    30,
      28,    29,    30,    56,    57,    75,    29,    77,    78,    19,
      14,    15,    16,    17,    18,    68,    69,    31,    88,    23,
      28,     1,    31,    27,    28,    95,    96,     2,    81,    33,
      -1,    -1,    -1,     0,     1,   105,     3,     4,     5,     6,
      -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,     0,     1,    33,     3,     4,     5,
       6,    -1,    -1,    -1,    -1,    -1,    12,    13,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,     0,     1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,    -1,    -1,    33,    14,    15,
      16,    17,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    27,    28,    -1,    -1,     0,     1,    33,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,     0,     1,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,     1,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,    13,
      14,    15,    16,    17,    18,     0,     1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    14,
      15,    16,    17,    18,     0,     1,    -1,    -1,    23,    -1,
      -1,    -1,    27,    28,    -1,    -1,    11,    12,    14,    15,
      16,    17,    18,    -1,    19,    20,    21,    23,    -1,    24,
      -1,    27,    28,    -1,    -1,    -1,    31,    32,    14,    15,
      16,    17,    18,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    27,    28
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    12,
      13,    14,    15,    16,    17,    18,    23,    24,    25,    26,
      27,    28,    29,    30,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,     1,    39,    41,    17,
      18,    38,    40,    41,    28,    29,    46,    27,    28,    38,
      37,    38,    37,    38,    38,    12,     3,    27,    41,    30,
       7,     8,     9,    38,    41,    11,    12,    19,    20,    21,
      31,    32,    45,    31,     0,    41,    13,    33,    41,     1,
       1,    33,    36,    37,    38,    43,    46,    45,    41,    38,
      38,    36,    29,    29,    38,    41,    41,    28,    29,    28,
      29,    28,    17,    18,    38,    41,    29,    31,    19,    31,
      28,    29,    28
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (p, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, p)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, p); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct strparser *p)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, p)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    struct strparser *p;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (p);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, struct strparser *p)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, p)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    struct strparser *p;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, p);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, struct strparser *p)
#else
static void
yy_reduce_print (yyvsp, yyrule, p)
    YYSTYPE *yyvsp;
    int yyrule;
    struct strparser *p;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , p);
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, p); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, struct strparser *p)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, p)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    struct strparser *p;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (p);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (struct strparser *p);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (struct strparser *p)
#else
int
yyparse (p)
    struct strparser *p;
#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 634 "src/libs/calcmd/parsecmd.y"
    { p->date = (yyvsp[(1) - (1)].dateval);; }
    break;

  case 4:
#line 635 "src/libs/calcmd/parsecmd.y"
    { p->date = (yyvsp[(2) - (2)].dateval); }
    break;

  case 5:
#line 636 "src/libs/calcmd/parsecmd.y"
    { p->date = (yyvsp[(1) - (2)].dateval); }
    break;

  case 7:
#line 640 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = force_evening((yyvsp[(2) - (2)].dateval));                   }
    break;

  case 8:
#line 641 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = force_morning((yyvsp[(2) - (2)].dateval));                   }
    break;

  case 9:
#line 645 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_daterange_from_timeranges(p, (yyvsp[(1) - (3)].dateval), (yyvsp[(3) - (3)].dateval)); 
    }
    break;

  case 11:
#line 651 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_time(p, p->defaults, (yyvsp[(1) - (1)].intval), 0, -1);   }
    break;

  case 12:
#line 652 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_time(p, p->defaults, (yyvsp[(1) - (3)].intval), (yyvsp[(3) - (3)].intval), -1);  }
    break;

  case 13:
#line 653 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_time(p, p->defaults, (yyvsp[(1) - (2)].intval), 0, -1);   }
    break;

  case 14:
#line 654 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_time(p, p->defaults, (yyvsp[(1) - (2)].intval), 0, (yyvsp[(2) - (2)].intval));   }
    break;

  case 15:
#line 656 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_time(p, p->defaults, (yyvsp[(1) - (4)].intval), (yyvsp[(3) - (4)].intval), (yyvsp[(4) - (4)].intval)); 
    }
    break;

  case 16:
#line 659 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_time(p, p->defaults, 12, 0, 0);    }
    break;

  case 17:
#line 661 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_daterange_from_timeranges (p, new_time(p, p->defaults, 23, 59, 0),
                                               new_time(p, p->defaults, 25, 0, 0));
    }
    break;

  case 18:
#line 666 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_daterange_from_timeranges (p, new_time(p, p->defaults, 12, 0, 0),
                                               new_time(p, p->defaults, 17, 59, 0));
    }
    break;

  case 19:
#line 671 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_daterange_from_timeranges (p, new_time(p, p->defaults, 4, 0, 0),
                                               new_time(p, p->defaults, 11, 59, 0));
    }
    break;

  case 20:
#line 676 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_daterange_from_timeranges (p, new_time(p, p->defaults, 18, 0, 0),
                                               new_time(p, p->defaults, 23, 59, 0));
    }
    break;

  case 21:
#line 680 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 22:
#line 681 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 23:
#line 682 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 24:
#line 683 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 25:
#line 684 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 27:
#line 689 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_daterange_from_dateranges(p, (yyvsp[(1) - (3)].dateval), (yyvsp[(3) - (3)].dateval)); 
    }
    break;

  case 28:
#line 693 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_datetime(p, new_dayofweek (p, p->defaults, (yyvsp[(2) - (3)].intval)), 
                             force_morning ((yyvsp[(1) - (3)].dateval)));
    }
    break;

  case 29:
#line 698 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_datetime(p, new_dayofweek (p, p->defaults, (yyvsp[(2) - (3)].intval)), 
                             force_evening ((yyvsp[(1) - (3)].dateval)));
    }
    break;

  case 30:
#line 702 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_datetime(p, (yyvsp[(1) - (2)].dateval), (yyvsp[(2) - (2)].dateval));               }
    break;

  case 32:
#line 704 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_datetime(p, (yyvsp[(2) - (2)].dateval), (yyvsp[(1) - (2)].dateval));               }
    break;

  case 34:
#line 709 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = daterange_skip((yyvsp[(2) - (2)].dateval), 1);            }
    break;

  case 35:
#line 710 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_weekend (p, p->defaults);          }
    break;

  case 36:
#line 711 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_weekend (p, p->defaults);          }
    break;

  case 37:
#line 712 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_week    (p, p->defaults);          }
    break;

  case 38:
#line 713 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_week    (p, p->defaults);          }
    break;

  case 39:
#line 714 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_month   (p, p->defaults, -1, -1);  }
    break;

  case 40:
#line 715 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_month   (p, p->defaults, -1, -1);  }
    break;

  case 41:
#line 718 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = daterange_skip((yyvsp[(2) - (2)].dateval), 1);                 }
    break;

  case 42:
#line 719 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 43:
#line 720 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_datetime(p, (yyvsp[(1) - (2)].dateval), (yyvsp[(2) - (2)].dateval));               }
    break;

  case 44:
#line 721 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_datetime(p, (yyvsp[(2) - (2)].dateval), (yyvsp[(1) - (2)].dateval));               }
    break;

  case 47:
#line 725 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = daterange_skip (new_date(p, p->defaults, -1, -1, -1), 1); 
    }
    break;

  case 48:
#line 729 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = daterange_skip (new_date(p, p->defaults, -1, -1, -1), -1); 
    }
    break;

  case 49:
#line 732 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_date(p, p->defaults, -1, -1, -1);  }
    break;

  case 50:
#line 733 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 51:
#line 735 "src/libs/calcmd/parsecmd.y"
    {
        (yyvsp[(3) - (3)].dateval)->skip = SKIP_DAY;
        (yyval.dateval) = daterange_skip((yyvsp[(3) - (3)].dateval), (yyvsp[(1) - (3)].intval));
    }
    break;

  case 52:
#line 740 "src/libs/calcmd/parsecmd.y"
    {
        (yyvsp[(3) - (3)].dateval)->skip = SKIP_WEEK;
        (yyval.dateval) = daterange_skip ((yyvsp[(3) - (3)].dateval), (yyvsp[(1) - (3)].intval));
    }
    break;

  case 53:
#line 744 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(2) - (2)].dateval);                                    }
    break;

  case 54:
#line 745 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = (yyvsp[(1) - (2)].dateval);                                    }
    break;

  case 57:
#line 752 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_dayofweek(p, p->defaults, (yyvsp[(1) - (1)].intval));     }
    break;

  case 58:
#line 753 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_month(p, p->defaults, (yyvsp[(1) - (1)].intval), -1);     }
    break;

  case 59:
#line 754 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_day_of_month(p, p->defaults, (yyvsp[(1) - (1)].intval));  }
    break;

  case 60:
#line 758 "src/libs/calcmd/parsecmd.y"
    { 
        if ((yyvsp[(1) - (3)].intval) > 12) { /* dd-mm */
            (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(3) - (3)].intval)-1, (yyvsp[(1) - (3)].intval));
        } else if ((yyvsp[(3) - (3)].intval) > 12) { /* mm-dd */
            (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(1) - (3)].intval)-1, (yyvsp[(3) - (3)].intval));
        } else { /* assume mm-dd ... TODO use locale */
            (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(1) - (3)].intval)-1, (yyvsp[(3) - (3)].intval));
        }
    }
    break;

  case 61:
#line 768 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_date (p, p->defaults, (yyvsp[(3) - (3)].intval), (yyvsp[(1) - (3)].intval)-1, -1);         
    }
    break;

  case 62:
#line 773 "src/libs/calcmd/parsecmd.y"
    { 
        if ((yyvsp[(1) - (5)].intval) > 12) { /* dd-mm-yy */
            (yyval.dateval) = new_date(p, p->defaults, TWO_DIGIT_YEAR((yyvsp[(5) - (5)].intval)), (yyvsp[(3) - (5)].intval)-1, (yyvsp[(1) - (5)].intval));
        } else if ((yyvsp[(3) - (5)].intval) > 12) { /* mm-dd-yy */
            (yyval.dateval) = new_date(p, p->defaults, TWO_DIGIT_YEAR((yyvsp[(5) - (5)].intval)), (yyvsp[(1) - (5)].intval)-1, (yyvsp[(3) - (5)].intval));
        } else { /* assume mm-dd-yy ... TODO: use locale */
            (yyval.dateval) = new_date(p, p->defaults, TWO_DIGIT_YEAR((yyvsp[(5) - (5)].intval)), (yyvsp[(1) - (5)].intval)-1, (yyvsp[(3) - (5)].intval));
        }
    }
    break;

  case 63:
#line 783 "src/libs/calcmd/parsecmd.y"
    {
            (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(1) - (5)].intval), (yyvsp[(3) - (5)].intval)-1, (yyvsp[(5) - (5)].intval));
    }
    break;

  case 64:
#line 787 "src/libs/calcmd/parsecmd.y"
    { 
        if ((yyvsp[(1) - (5)].intval) > 12) { /* dd-mm-yyyy */
            (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(5) - (5)].intval), (yyvsp[(3) - (5)].intval)-1, (yyvsp[(1) - (5)].intval));
        } else if ((yyvsp[(3) - (5)].intval) > 12) { /* mm-dd-yyyy */
            (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(5) - (5)].intval), (yyvsp[(1) - (5)].intval)-1, (yyvsp[(3) - (5)].intval));
        } else { /* assume mm-dd-yyyy TODO: use locale */
            (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(5) - (5)].intval), (yyvsp[(1) - (5)].intval)-1, (yyvsp[(3) - (5)].intval));
        }
    }
    break;

  case 65:
#line 796 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(2) - (2)].intval), (yyvsp[(1) - (2)].intval));  }
    break;

  case 66:
#line 797 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval));  }
    break;

  case 67:
#line 798 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(2) - (2)].intval), (yyvsp[(1) - (2)].intval));  }
    break;

  case 68:
#line 799 "src/libs/calcmd/parsecmd.y"
    { (yyval.dateval) = new_date(p, p->defaults, -1, (yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval));  }
    break;

  case 69:
#line 801 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_month(p, p->defaults, (yyvsp[(1) - (2)].intval), (yyvsp[(2) - (2)].intval));
    }
    break;

  case 70:
#line 805 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(3) - (3)].intval), (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval));  
    }
    break;

  case 71:
#line 809 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(3) - (3)].intval), (yyvsp[(1) - (3)].intval), (yyvsp[(2) - (3)].intval));  
    }
    break;

  case 72:
#line 813 "src/libs/calcmd/parsecmd.y"
    {
        (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(3) - (3)].intval), (yyvsp[(2) - (3)].intval), (yyvsp[(1) - (3)].intval));  
    }
    break;

  case 73:
#line 817 "src/libs/calcmd/parsecmd.y"
    { 
        (yyval.dateval) = new_date(p, p->defaults, (yyvsp[(3) - (3)].intval), (yyvsp[(1) - (3)].intval), (yyvsp[(2) - (3)].intval));  
    }
    break;

  case 75:
#line 829 "src/libs/calcmd/parsecmd.y"
    { (yyval.intval) = (yyvsp[(2) - (2)].intval);                                  }
    break;

  case 77:
#line 832 "src/libs/calcmd/parsecmd.y"
    { (yyval.intval) = (yyvsp[(2) - (2)].intval);                                  }
    break;


/* Line 1267 of yacc.c.  */
#line 2504 "src/libs/calcmd/parsecmd.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (p, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (p, yymsg);
	  }
	else
	  {
	    yyerror (p, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, p);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, p);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (p, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, p);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, p);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 835 "src/libs/calcmd/parsecmd.y"


struct symboldef {
    int token;
    const char *symbol;
    int val;
};

static const struct symboldef tokens[] = {
    { THRU,         "through",      0  },
    { THRU,         "thru",         0  },
    { THRU,         "to",           0  },
    { THRU,         "until",        0  },
    { THRU,         "til",          0  },
    { THRU,         "till",         0  },


    { A,            "a",            0  }, 
    { AT,           "at",           0  }, 
    { ON,           "on",           0  },
    { THE,          "the",          0  },
    { OF,           "of",           0  },
    { THIS,         "this",         0  },

    { NEXT,         "next",         1  },

    { DAYSFROM,     "days",         0  }, /* hacky */
    { DAYSFROM,     "day",          0  },
    { WEEKSFROM,    "weeks",        0  },
    { WEEKSFROM,    "week",         0  },
    { WEEKSFROM,    "wk",           0  },
    { WEEKSFROM,    "wks",          0  },
    
    { TODAY,        "today",        0  },
    { TOMORROW,     "tomorrow",     0  },
    { YESTERDAY,    "yesterday",    0  },

    { NOON,         "noon",         0  },
    { MORNING,      "morning",      0  },
    { MORNING,      "morn",         0  },
    { AFTERNOON,    "afternoon",    0  },
    { EVENING,      "evening",      0  },
    { EVENING,      "eve",          0  },
    { EVENING,      "night",        0  },
    { EVENING,      "nite",         0  },
    { EVENING,      "tonite",       0  },
    { EVENING,      "tonight",      0  },
    { MIDNIGHT,     "midnight",     0  },
    { MIDNIGHT,     "midnite",      0  },

    { WEEKEND,      "weekend",      0  },
    { WEEKEND,      "wknd",         0  },

    { WEEK,         "week",         0  },
    { WEEK,         "wk",           0  },

    { MONTH,        "month",        0  },
    { MONTH,        "mnth",         0  },
    { MONTH,        "mth",          0  },
    { YEAR,         "year",         0  },
    { MONTH,        "yr",           0  },

    { DTDAYOFWEEK,  "sunday",       0  },
    { DTDAYOFWEEK,  "sun",          0  },
    { DTDAYOFWEEK,  "monday",       1  },
    { DTDAYOFWEEK,  "mon",          1  },
    { DTDAYOFWEEK,  "tuesday",      2  },
    { DTDAYOFWEEK,  "tues",         2  },
    { DTDAYOFWEEK,  "tue",          2  },
    { DTDAYOFWEEK,  "wednesday",    3  },
    { DTDAYOFWEEK,  "weds",         3  },
    { DTDAYOFWEEK,  "wed",          3  },
    { DTDAYOFWEEK,  "thursday",     4  },
    { DTDAYOFWEEK,  "thurs",        4  },
    { DTDAYOFWEEK,  "thur" ,        4  },
    { DTDAYOFWEEK,  "thu",          4  },
    { DTDAYOFWEEK,  "friday",       5  },
    { DTDAYOFWEEK,  "fri"   ,       5  },
    { DTDAYOFWEEK,  "saturday",     6  },
    { DTDAYOFWEEK,  "sat",          6  },

    { DTMONTH,      "january",      0  },
    { DTMONTH,      "jan",          0  },
    { DTMONTH,      "february",     1  },
    { DTMONTH,      "feb",          1  },
    { DTMONTH,      "march",        2  },
    { DTMONTH,      "mar",          2  },
    { DTMONTH,      "april",        3  },
    { DTMONTH,      "apr",          3  },
    { DTMONTH,      "may",          4  },
    { DTMONTH,      "june",         5  },
    { DTMONTH,      "jun",          5  },
    { DTMONTH,      "july",         6  },
    { DTMONTH,      "jul",          6  },
    { DTMONTH,      "august",       7  },
    { DTMONTH,      "aug",          7  },
    { DTMONTH,      "september",    8  },
    { DTMONTH,      "sept",         8  },
    { DTMONTH,      "sep",          8  },
    { DTMONTH,      "october",      9  },
    { DTMONTH,      "oct",          9  },
    { DTMONTH,      "november",     10 },
    { DTMONTH,      "nov",          10 },
    { DTMONTH,      "december",     11 },
    { DTMONTH,      "dec",          11 },

    { ORDNUM,       "first",        1  },
    { ORDNUM,       "second",       2  },
    { ORDNUM,       "third",        3  },
    { ORDNUM,       "fourth",       4  },
    { ORDNUM,       "fifth",        5  },
    { ORDNUM,       "sixth",        6  },
    { ORDNUM,       "seventh",      7  },
    { ORDNUM,       "eighth",       8  },
    { ORDNUM,       "ninth",        9  },
    { ORDNUM,       "tenth",        10 },
    { ORDNUM,       "eleventh",     11 },
    { ORDNUM,       "twelfth",      12 },
    { ORDNUM,       "thirteenth",   13 },
    { ORDNUM,       "fourteenth",   14 },
    { ORDNUM,       "fifteenth",    15 },
    { ORDNUM,       "sixteenth",    16 },
    { ORDNUM,       "seventeenth",  17 },
    { ORDNUM,       "eighteenth",   18 },
    { ORDNUM,       "nineteenth",   19 },
    { ORDNUM,       "twentieth",    20 },

    { AMPM,         "am",           0  },
    { AMPM,         "pm",           1  },
    { OCLOCK,       "o'clock",      0  },
    { OCLOCK,       "oclock",       0  },

    { 0,         NULL,              0  },
};


static const struct symboldef *
match_token (char *str)
{
    const struct symboldef *tok;

    for (tok = &tokens[0]; 
         tok->symbol; 
         tok++) 
    {
        if (!XplStrCaseCmp (tok->symbol, str)) {
            return tok;
        }
    }
    return NULL;
}


static const struct symboldef *
find_token (int token)
{
    const struct symboldef *tok;

    for (tok = &tokens[0]; 
         tok->symbol; 
         tok++)
    {
        if (tok->token == token) {
            return tok;
        }
    }

    return NULL;
}



int
yylex (YYSTYPE *lvalp, struct strparser *p)
{
    int c;
    int nextc;

    while (1) {
        /* skip whitespace */

        for (; c = p->str[p->idx], isspace(c); p->idx++) {
            if (p->dptr != p->desc && !isspace (p->dptr[-1])) {
                *(p->dptr++) = ' ';
            }
        }

        /* process number */
        if (isdigit(c)) {
            int numval = 0;

            for (; c = p->str[p->idx], isdigit(c); p->idx++) {
                numval *= 10;
                numval += c - '0';
            }
            lvalp->intval = numval;
            if (numval > 1000) {
                return YEARNUM;
            } else if (c) {
                nextc = p->str[p->idx+1];
                if ((('s' == c || 'S' == c) &&
                     ('t' == nextc || 'T' == nextc)) ||
                    (('n' == c || 'N' == c) &&
                     ('d' == nextc || 'D' == nextc)) || 
                    (('r' == c || 'R' == c) &&
                     ('d' == nextc || 'D' == nextc)) || 
                    (('t' == c || 'T' == c) &&
                     ('h' == nextc || 'H' == nextc)))
                {
                    /* ordinal number */
                    p->idx += 2;
                    if (',' == p->str[p->idx]) {
                        p->idx++;
                    }
                    return ORDNUM;
                }
            }
            return NUM;
        } else if (isalpha(c)) {
            char buf[256];
            int i = 0;
            const struct symboldef *token;

            for (; 
                 c = p->str[p->idx], c && (isalpha(c) || '\'' == c); 
                 p->idx++) 
            {
                buf[i++] = c;
                if (i >= 255) break;
            }
            buf[i] = 0;

            token = match_token (buf);
            if (token) {
                /* behold some awful hacking to get around the 1-token 
                   lookahead of bison by using the scanner: */

                if (A == token->token) {
                    /* valid A tokens: "a week from tuesday", etc.
                       ignore: everything
                    */
                    
                    char *skip;
                    
                    for (skip = &p->str[p->idx]; isspace(*skip); skip++);
                    if (!XplStrNCaseCmp ("week", skip, 4) ||
                        !XplStrNCaseCmp ("wk", skip, 2) ||
                        !XplStrNCaseCmp ("day", skip, 3)) 
                    {
                        lvalp->intval = 1;
                        return NUM;
                    } else {
                        token = NULL;
                    }
                } else if (AT == token->token) {
                    /* valid AT tokens: "lunch at noon", "lunch at 3pm"
                       ignore: "lunch at Legal Seafoods", etc.
                    */
                    
                    char *skip;
                    
                    for (skip = &p->str[p->idx]; isspace(*skip); skip++);
                    if (!isdigit(*skip) && XplStrNCaseCmp ("noon", skip, 4)) {
                        token = NULL;
                    }
                } else if (DAYSFROM == token->token ||
                           WEEKSFROM == token->token) 
                {
                    /* DAYSFROM token actually only sees DAYS; check for
                       and consume following "from"
                    */

                    int idx2;

                    for (idx2 = p->idx; isspace (p->str[idx2]); idx2++);

                    if (!XplStrNCaseCmp (&p->str[idx2], "from", 4)) {
                        p->idx = idx2 + 4;
                    } else if (!XplStrNCaseCmp (&p->str[idx2], "after", 5)) {
                        p->idx = idx2 + 5;
                    } else {
                        /* no "from" to consume, pass back WEEK token: */
                        if (WEEKSFROM == token->token) {
                            token = find_token (WEEK);
                        } else {
                            token = NULL;
                        }
                    }
                } else if (OF == token->token) {
                    /* valid OF tokens: "4th of july"
                       ignore: "fri meeting rest of team", etc.
                    */

                    char *skip;

                    for (skip = p->str + p->idx; isspace(*skip); skip++);
                    if (!isdigit(*skip) && *skip) {
                        char *ptr2;
                        char tmp;
 
                        for (ptr2 = skip; !isspace(*ptr2); ptr2++);
                        tmp = *ptr2;
                        *ptr2 = 0;
                        
                        if (!match_token (skip)) {
                            token = NULL;
                        }
                        *ptr2 = tmp;
                    }                   
                } else if (ON == token->token) {
                    /* valid ON tokens: "golf on friday", "interview on 3 July"
                       ignore: "3pm lecture on parsing technology"
                    */
                    char *skip;
                    
                    for (skip = p->str + p->idx; isspace(*skip); skip++);
                    if (!isdigit(*skip) && *skip) {
                        char *ptr2;
                        char tmp;
 
                        for (ptr2 = skip; !isspace(*ptr2); ptr2++);
                        tmp = *ptr2;
                        *ptr2 = 0;
                        
                        
                        if (!match_token (skip)) {
                            token = NULL;
                        }
                        *ptr2 = tmp;
                    }
                } else if (THE == token->token) {
                    /* ignore unless it's followed by an ordnum */

                    char *skip;
                    
                    for (skip = &p->str[p->idx]; isspace(*skip); skip++);
                    if (!isdigit(*skip)) {
                        char *ptr2;
                        char tmp;
                        const struct symboldef *nexttoken;
 
                        for (ptr2 = skip; !isspace(*ptr2); ptr2++);
                        tmp = *ptr2;
                        *ptr2 = 0;
                        nexttoken = match_token (skip);
                        *ptr2 = tmp;
                        if (!nexttoken) {
                            token = NULL;
                        } else if (!XplStrNCaseCmp ("week", skip, 4) ||
                                   !XplStrNCaseCmp ("wk", skip, 2) ||
                                   !XplStrNCaseCmp ("day", skip, 3))
                        {
                            lvalp->intval = 1;
                            return NUM;
                        } else if (ORDNUM != nexttoken->token) {
                            token = NULL;
                        }
                    } else {
                        while (isdigit(*++skip));
                        if (!skip) {
                            token = NULL;
                        } else {
                            nextc = skip[1];
                            if (!((('s' == *skip || 'S' == *skip) &&
                                   ('t' == nextc || 'T' == nextc)) ||
                                  (('n' == *skip || 'N' == *skip) &&
                                   ('d' == nextc || 'D' == nextc)) || 
                                  (('r' == *skip || 'R' == *skip) &&
                                   ('d' == nextc || 'D' == nextc)) || 
                                  (('t' == *skip || 'T' == *skip) &&
                                   ('h' == nextc || 'H' == nextc))))
                            {
                                token = NULL;
                            }
                        }
                    }
                } else if (THIS == token->token || 
                           THRU == token->token) 
                {
                    /* valid: "this weekend" "this monday"
                       ignore: "this stupid meeting at 3pm" 
                       valid: "1 to 3" "weds thru fri afternoon"
                       ignore: "try to wake up"
                    */
                    char *skip;

                    for (skip = p->str + p->idx; isspace(*skip); skip++);
                    if (!isdigit(*skip) && *skip) {
                        char *ptr2;
                        char tmp;
 
                        for (ptr2 = skip; !isspace(*ptr2); ptr2++);
                        tmp = *ptr2;
                        *ptr2 = 0;
                        
                        if (!match_token (skip)) {
                            token = NULL;
                        }
                        *ptr2 = tmp;
                    }
                }
            }
            if (token) {
                for (; c = p->str[p->idx], c && !isspace(c); p->idx++);
                lvalp->intval = token->val;
                return token->token;
            } else {
                memcpy (p->dptr, buf, i);
                p->dptr += i;
            }
        } else if ('-' == c || '/' == c || '.' == c) {
            nextc = p->str[p->idx+1];
            if (isdigit (nextc)) {
                p->idx++;
                return DASH;
            } else {
                *p->dptr++ = c;
                p->idx++;
            }
        } else if (':' == c) {
            nextc = p->str[p->idx+1];
            if (isdigit (nextc)) {
                p->idx++;
                return COLON;
            } else {
                *p->dptr++ = c;
                p->idx++;
            }
        } else if ('"' == c) {
            /* quoted strings are always descriptions */
            while ((c = p->str[++p->idx])) {
                if ('"' == c) {
                    ++p->idx;
                    break;
                } else if ('\\' == c) {
                    if (!p->str[++p->idx]) {
                        break;
                    }
                }
                *(p->dptr++) = c;
            }
        } else if (0 == c) {
            return c;
        } else {
            /* anything we don't recognize goes into the description */
            *(p->dptr++) = c;
            p->idx++;
        }
    }
}



/* CalCmdParseCommand
 *
 * Parses command from buf into calendar command struct cmd
 *
 * Return:
 *     non-zero on success
 */

int
CalCmdParseCommand (char *buf, CalCmdCommand *cmd, BongoCalTimezone *tz)
{
    struct strparser p;
    size_t size = sizeof(cmd->data);
    BongoCalTime now;
    int retval = 0;
    
    while (isspace(*buf)) { 
        buf++; 
    }
    if (!XplStrNCaseCmp(buf, "help", 4)) {
        cmd->type = CALCMD_HELP;
        strncpy(cmd->data, &buf[4], size);
        cmd->data[size-1] = '\0';        
        return 1;
    }
    if (!init_strparser(&p, buf)) {
        return retval;
    }    
    if (!setjmp(p.bailenv)) {
        if (BaseTime) {
            now = BongoCalTimeNewFromUint64(BaseTime, FALSE, NULL);
        } else {
            now = BongoCalTimeNow(NULL);
        }       
        cmd->begin = cmd->end = now;

        p.defaults = new_daterange_from_tms(&p, &cmd->begin, &cmd->end);

        yyparse(&p);

        while (isspace(*--p.dptr));
        *++p.dptr = 0;
        if (p.date) {
            memcpy(&cmd->begin, &p.date->begin, sizeof(BongoCalTime));
            memcpy(&cmd->end, &p.date->end, sizeof(BongoCalTime));

            /* FIXME: I think doing everything in utc then just
             * setting the timezone will work, but I'm not 100% sure */
            cmd->begin = BongoCalTimeSetTimezone(cmd->begin, tz);
            cmd->end = BongoCalTimeSetTimezone(cmd->end, tz);

            strncpy(cmd->data, p.desc, size);
            cmd->data[size-1] = 0;
            if (p.desc[0]) {
                cmd->type = CALCMD_NEW_APPT;
            } else {
                cmd->type = CALCMD_QUERY;
            }
            retval = 1;
        } 
    }

    destroy_strparser(&p);
    return retval;
}


int
CalCmdSetDebugMode (int flag)
{
    yydebug = flag;
    return flag;
}

int
CalCmdSetVerboseDebugMode (int flag)
{
    VerboseMode = flag;
    return flag;
}

time_t
CalCmdSetTestMode (time_t basetime)
{
    BaseTime = basetime;
    return BaseTime;
}

